' Ring Plane
' Program To create a Ring plane Starting at a given diameter And ending at a given diameter
' defining number of rings And hits per ring, CW Or CCW And an internal clearplane To avoid sides If needed.
' 
' Ver 1.00.00

Sub Main

Dim  App As Object
Set App = CreateObject("PCDLRN.Application")
Dim  Part As Object
Set  Part = App.ActivePartProgram
Dim  Cmds As Object
Set Cmds = Part.Commands
Dim Cmd As Object


' Dimensioning Variables And setting them all To zero

' Hit Direction CW Or CCW
Dim HDirection   As Integer
Let HDirection = 0

' Hit Pattern: Radial Or Orbital
Dim Hpattern   As Integer
Let Hpattern = 0

' Clearplane 0 = no 
Dim  CP As Integer
Let CP = 0

' Number of Hits total number of hits In Plane
Dim NHits As Integer
Let NHits = 0

' Number of hits In Each ring
Dim NHitsRing As Integer
Let NHitsRing = 0

' Current Angle For Current Hit
Dim  HitAngle As Double
Let HitAngle = 0

' Speaks For itself
Dim HitAngleInc As Double
Let HitAngleInc = 0

' I know it's hard coded but, Not tricky but it's a constant anyway.
Dim PI As Double
Let PI = 3.141592654

' Number of rings To measure: 
Dim NRings As Integer
Let NRings = 0

' start radius, End radius And radius increment
Dim SRadius#, ERadius#, RadiusInc#
Let SRadius = 0
Let ERadius = 0
Let RadiusInc = 0

' the center of the plane And the center of the current hit
' allows inputs To check the depth of a counterbore With a Single ring of hits anywhere On the part.
Dim X_theo#, Y_theo#, Z_theo#, Xtheo#, Ytheo#
Let X_theo = 0
Let Y_theo = 0
Let Z_theo = 0
Let Xtheo = 0
Let Ytheo = 0

' a place To hold the Name of the plane
Dim PLN_ID$ 

' Building the Dialog box
Begin Dialog DLG_RING_PLANE 106,15,163,177, "Ring Plane"

  TextBox 2, 1,40,10, .EditBox_1
  Text 45,1,55,10, "PLN ID"

  TextBox 2,14,35,10, .EditBox_2
  Text 45,14,55,10, "X Origin"
 
  TextBox 2,27,35,10, .EditBox_3
  Text 45,27,55,10, "Y Origin"

  TextBox 2,40,35,10, .EditBox_4
  Text 45,40,55,10, "Z Origin"

  TextBox 2,53,35,10, .EditBox_5
  Text 45,53,55,10, "Number of Rings"

  CheckBox 65,120,100,12, "Use Internal Clearplane", . chk1

  TextBox 2,75,35,10, .EditBox_6
   Text 45,75,55,10, "Start Diameter"

  TextBox 2,88,35,10, .EditBox_7
  Text 45,88,55,10, "End Diameter"

  TextBox 2,103,35,10, .EditBox_8
  Text 45,103,55,10, "Hits Per Ring"


  GroupBox 95,1,55,45, "Hit Pattern", .GroupBox1
  GroupBox 95,75,55,45, "Hit Direction", .GroupBox2

  OptionGroup .OptionGroup1
  OptionButton 100,17,40,8, "Radial", .OptionButton1
  OptionButton 100, 28,40,8, "Orbital", .OptionButton2

  OptionGroup .OptionGroup2
  OptionButton 100, 91,40,8, "CW", .OptionButton3
  OptionButton 100, 102, 40,8, "CCW", .OptionButton4
 
  OKButton 30,160,44,12
  CancelButton 82,160,52,12
End Dialog

Dim dlg1 As DLG_RING_PLANE
buttonval = Dialog(dlg1)

' Re-assigning Dialog box variables To something more descriptive To make reading the program easier
Let PLN_ID = dlg1.EditBox_1
Let X_theo = dlg1.EditBox_2
Let Y_theo = dlg1.EditBox_3
Let Z_theo = dlg1.EditBox_4
Let NRings = dlg1.EditBox_5
Let SRadius = dlg1.EditBox_6/2
Let ERadius = dlg1.EditBox_7/2
Let NHitsRing = dlg1.EditBox_8
Let NHits = NRings * NHitsRing
Let HitAngle = 0
Let HitAngleInc = (2*PI) / NHitsRing ' putting the angle into radians.

' If there is only one ring, we want To avoid trying To figure out a radius increment. 
' Still can't Get dividing by zero To work right
If NRings > 1 Then
    Let RadiusInc = (ERadius - SRadius) / (NRings - 1)
Else
    Let RadiusInc = 0
End If

If dlg1.OptionGroup2 = 1 Then
' direction is CCW
  Let HDirection = 1
  End If

If dlg1.OptionGroup1 = 1 Then
' pattern is Orbital
  Let Hpattern = 1
 End If

If dlg1.chk1 = 1 Then
' use internal clearplane
 Let CP = 1
End If

' Output Plane 'header' Then start into proper Loop For chosen pattern of hits.
Set Cmd = Cmds.Add(MEASURED_PLANE, True)
    Cmd.Marked = True
    retval = Cmd.PutText (X_theo, THEO_X, 0)
    retval = Cmd.PutText (Y_theo, THEO_Y, 0)
    retval = Cmd.PutText (Z_theo, THEO_Z, 0)
    retval = Cmd.PutText ("0", THEO_I, 0)
    retval = Cmd.PutText ("0", THEO_J, 0)
    retval = Cmd.PutText ("1", THEO_K, 0)
    retval = Cmd.PutText (X_theo, MEAS_X, 0)
    retval = Cmd.PutText (Y_theo, MEAS_Y, 0)
    retval = Cmd.PutText (Z_theo, MEAS_Z, 0)
    retval = Cmd.PutText ("0", MEAS_I, 0)
    retval = Cmd.PutText ("0", MEAS_J, 0)
    retval = Cmd.PutText ("1", MEAS_K, 0)
    retval = Cmd.PutText( PLN_ID, ID, 0)
    retval = Cmd.SetToggleString (1, COORD_TYPE, 0)
    retval = Cmd.SetToggleString (2,  DISPLAY_TYPE,0)
    retval = Cmd.PutText (NHits, N_HITS, 0)

If Hpattern = 1 Then ' Orbital

For i = 1 To NRings
    For j = 1 To NHitsRing
        
        If HDirection = 0 Then 
            Xtheo = SRadius * sin(HitAngle) + X_theo
            Ytheo =  SRadius * cos(HitAngle) + Y_theo
        Else
            Xtheo = X_theo + SRadius * sin(HitAngle)
            Ytheo = Y_theo + SRadius * cos(HitAngle) * -1
        End If
       Set Cmd = Cmds.Add(BASIC_HIT, True)
          Cmd.Marked = True
          retval = Cmd.PutText (Xtheo, THEO_X, 0)
          retval = Cmd.PutText (Ytheo, THEO_Y, 0)
          retval = Cmd.PutText (Z_theo, THEO_Z, 0)
          retval = Cmd.PutText ("0", THEO_I, 0)
          retval = Cmd.PutText ("0", THEO_J, 0)
          retval = Cmd.PutText ("1", THEO_K, 0)
          retval = Cmd.PutText (Xtheo, MEAS_X, 0)
          retval = Cmd.PutText (Ytheo, MEAS_Y, 0)
          retval = Cmd.PutText (Z_theo, MEAS_Z, 0)
          retval = Cmd.PutText ("0", MEAS_I, 0)
          retval = Cmd.PutText ("0", MEAS_J, 0)
          retval = Cmd.PutText ("1", MEAS_K, 0)
          retval = Cmd.PutText( PLN_ID, ID, 0)
          retval = Cmd.SetToggleString (1, NORM_RELEARN, 0)
          retval = Cmd.SetToggleString (2,  USE_THEO,0)

        If CP = 1 Then 
             Set Cmd = Cmds.Add(MOVE_CLEARP, True)
                  Cmd.Marked = True
        End If
        ' incrementing the angle, by the way the angle is In radians
       Let HitAngle = HitAngle + HitAngleInc
      

    Next j
  
  ' more incrementing of counters ans such.
  Let HitAngle = HitAngle - HitAngleInc
  Let SRadius = SRadius + RadiusInc
Next i

Else ' If it is Not orbital it must be Radial
   
     For i = 1 To NHitsRing
          For j = 1 To NRings 
                  If HDirection = 0 Then 
                       Xtheo = SRadius * sin(HitAngle) + X_theo
                       Ytheo =  SRadius * cos(HitAngle) + Y_theo
                  Else
                       Xtheo = X_theo + SRadius * sin(HitAngle)
                      Ytheo = Y_theo + SRadius * cos(HitAngle) * -1
                  End If
                Set Cmd = Cmds.Add(BASIC_HIT, True)
                      Cmd.Marked = True
                      retval = Cmd.PutText (Xtheo, THEO_X, 0)
                        retval = Cmd.PutText (Ytheo, THEO_Y, 0)
                        retval = Cmd.PutText (Z_theo, THEO_Z, 0)
                        retval = Cmd.PutText ("0", THEO_I, 0)
                        retval = Cmd.PutText ("0", THEO_J, 0)
                        retval = Cmd.PutText ("1", THEO_K, 0)
                        retval = Cmd.PutText (Xtheo, MEAS_X, 0)
                        retval = Cmd.PutText (Ytheo, MEAS_Y, 0)
                        retval = Cmd.PutText (Z_theo, MEAS_Z, 0)
                        retval = Cmd.PutText ("0", MEAS_I, 0)
                        retval = Cmd.PutText ("0", MEAS_J, 0)
                        retval = Cmd.PutText ("1", MEAS_K, 0)
                        retval = Cmd.PutText( PLN_ID, ID, 0)
                        retval = Cmd.SetToggleString (1, NORM_RELEARN, 0)
                        retval = Cmd.SetToggleString (2,  USE_THEO,0)

                  Let SRadius = SRadius + RadiusInc
                 
                  Next j
        ' doing the variable increment business
        Let SRadius = SRadius - RadiusInc
        Let HitAngle = HitAngle - HitAngleInc
        Let RadiusInc = RadiusInc * -1 ' flip flop the radius increment To allow bi-directional travel

        If CP = 1 Then ' it's '1' we want a clearplane
             Set Cmd = Cmds.Add(MOVE_CLEARP, True)
                  Cmd.Marked = True
        End If

       
Next i


          
End If

' speaks For itself
Set Cmd = Cmds.Add(END_MEASURED_FEATURE, True)
  Cmd.Marked = True
      
End Sub


  